Package org.apache.commons.dbutils.handlers

# Class BeanMapHandler<K,V>

java.lang.Object
org.apache.commons.dbutils.handlers.AbstractKeyedHandler<K,V>
org.apache.commons.dbutils.handlers.BeanMapHandler<K,V>

Type Parameters:
  `K` - the type of keys maintained by the returned map
  `V` - the type of the bean

All Implemented Interfaces:
  `ResultSetHandler<Map<K,V>>`

public class BeanMapHandler<K,V> extends AbstractKeyedHandler<K,V>

`ResultSetHandler` implementation that returns a Map of Beans. `ResultSet` rows are converted into Beans which are then stored in a Map under the given key.

If you had a Person table with a primary key column called ID, you could retrieve rows from the table like this:

     ResultSetHandler<Map<Long, Person>> h = new BeanMapHandler<Long, Person>(Person.class, "id");
     Map<Long, Person> found = queryRunner.query("select id, name, age from person", h);
     Person jane = found.get(1L); // jane's id is 1
     String janesName = jane.getName();
     Integer janesAge = jane.getAge();

Note that the "id" passed to BeanMapHandler can be in any case. The data type returned for id is dependent upon how your JDBC driver converts SQL column types from the Person table into Java types. The "name" and "age" columns are converted according to their property descriptors by DbUtils. </p>

This class is thread safe. </p>

Since:
  1.5
See Also:
  - `ResultSetHandler`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BeanMapHandler(Class<V> type)`
  Creates a new instance of BeanMapHandler.
  `BeanMapHandler(Class<V> type, int columnIndex)`
  Creates a new instance of BeanMapHandler.
  `BeanMapHandler(Class<V> type, String columnName)`
  Creates a new instance of BeanMapHandler.
  `BeanMapHandler(Class<V> type, RowProcessor convert)`
  Creates a new instance of BeanMapHandler.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected K`
  `createKey(ResultSet resultSet)`
  This factory method is called by `handle()` to retrieve the key value from the current `ResultSet` row.
  `protected V`
  `createRow(ResultSet resultSet)`
  This factory method is called by `handle()` to store the current `ResultSet` row in some object.

  ### Methods inherited from class org.apache.commons.dbutils.handlers.AbstractKeyedHandler

  `createMap, handle`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### BeanMapHandler

    public BeanMapHandler(Class<V> type)
    Creates a new instance of BeanMapHandler. The value of the first column of each row will be a key in the Map.
    Parameters:
      `type` - The Class that objects returned from `createRow()` are created from.

  - ### BeanMapHandler

    public BeanMapHandler(Class<V> type, int columnIndex)
    Creates a new instance of BeanMapHandler.
    Parameters:
      `type` - The Class that objects returned from `createRow()` are created from.
      `columnIndex` - The values to use as keys in the Map are retrieved from the column at this index.

  - ### BeanMapHandler

    public BeanMapHandler(Class<V> type, RowProcessor convert)
    Creates a new instance of BeanMapHandler. The value of the first column of each row will be a key in the Map.
    Parameters:
      `type` - The Class that objects returned from `createRow()` are created from.
      `convert` - The `RowProcessor` implementation to use when converting rows into Beans

  - ### BeanMapHandler

    public BeanMapHandler(Class<V> type, String columnName)
    Creates a new instance of BeanMapHandler.
    Parameters:
      `type` - The Class that objects returned from `createRow()` are created from.
      `columnName` - The values to use as keys in the Map are retrieved from the column with this name.

- ## Method Details

  - ### createKey

    protected K createKey(ResultSet resultSet) throws SQLException
    This factory method is called by `handle()` to retrieve the key value from the current `ResultSet` row.
    Specified by:
      `createKey` in class `AbstractKeyedHandler<K,V>`
    Parameters:
      `resultSet` - ResultSet to create a key from
    Returns:
      K from the configured key column name/index
    Throws:
      `SQLException` - if a database access error occurs
      `ClassCastException` - if the class datatype does not match the column type
    See Also:
      - `AbstractKeyedHandler.createKey(ResultSet)`

  - ### createRow

    protected V createRow(ResultSet resultSet) throws SQLException
    Description copied from class: `AbstractKeyedHandler`
    This factory method is called by `handle()` to store the current `ResultSet` row in some object.
    Specified by:
      `createRow` in class `AbstractKeyedHandler<K,V>`
    Parameters:
      `resultSet` - ResultSet to create a row from
    Returns:
      V object created from the current row
    Throws:
      `SQLException` - if a database access error occurs